/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class MaterialPool!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILEMATERIALPOOLINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGMaterialPoolBase.h"
#include "OSGMaterialPool.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  MaterialPoolBase::MaterialsFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::MaterialsFieldId);

const OSG::BitVector  MaterialPoolBase::RootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::RootFieldId);

const OSG::BitVector  MaterialPoolBase::LightRootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::LightRootFieldId);

const OSG::BitVector  MaterialPoolBase::OverlayRootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::OverlayRootFieldId);

const OSG::BitVector  MaterialPoolBase::LightSetsRootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::LightSetsRootFieldId);

const OSG::BitVector  MaterialPoolBase::ConstraintsRootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::ConstraintsRootFieldId);

const OSG::BitVector  MaterialPoolBase::CameraRootFieldMask = 
    (TypeTraits<BitVector>::One << MaterialPoolBase::CameraRootFieldId);

const OSG::BitVector MaterialPoolBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var MaterialPtr     MaterialPoolBase::_mfMaterials
    
*/
/*! \var NodePtr         MaterialPoolBase::_sfRoot
    
*/
/*! \var NodePtr         MaterialPoolBase::_sfLightRoot
    The root node for the light pool
*/
/*! \var NodePtr         MaterialPoolBase::_sfOverlayRoot
    The root node for all overlays
*/
/*! \var NodePtr         MaterialPoolBase::_sfLightSetsRoot
    The root node for all light link sets
*/
/*! \var NodePtr         MaterialPoolBase::_sfConstraintsRoot
    The root node for all constraints
*/
/*! \var NodePtr         MaterialPoolBase::_sfCameraRoot
    The root node for the camera pool
*/

//! MaterialPool description

FieldDescription *MaterialPoolBase::_desc[] = 
{
    new FieldDescription(MFMaterialPtr::getClassType(), 
                     "materials", 
                     MaterialsFieldId, MaterialsFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editMFMaterials)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "root", 
                     RootFieldId, RootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFRoot)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "lightRoot", 
                     LightRootFieldId, LightRootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFLightRoot)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "overlayRoot", 
                     OverlayRootFieldId, OverlayRootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFOverlayRoot)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "lightSetsRoot", 
                     LightSetsRootFieldId, LightSetsRootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFLightSetsRoot)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "constraintsRoot", 
                     ConstraintsRootFieldId, ConstraintsRootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFConstraintsRoot)),
    new FieldDescription(SFNodePtr::getClassType(), 
                     "cameraRoot", 
                     CameraRootFieldId, CameraRootFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&MaterialPoolBase::editSFCameraRoot))
};


FieldContainerType MaterialPoolBase::_type(
    "MaterialPool",
    "Group",
    NULL,
    reinterpret_cast<PrototypeCreateF>(&MaterialPoolBase::createEmpty),
    MaterialPool::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(MaterialPoolBase, MaterialPoolPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &MaterialPoolBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &MaterialPoolBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr MaterialPoolBase::shallowCopy(void) const 
{ 
    MaterialPoolPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const MaterialPool *>(this)); 

    return returnValue; 
}

UInt32 MaterialPoolBase::getContainerSize(void) const 
{ 
    return sizeof(MaterialPool); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void MaterialPoolBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl(static_cast<MaterialPoolBase *>(&other),
                          whichField);
}
#else
void MaterialPoolBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((MaterialPoolBase *) &other, whichField, sInfo);
}
void MaterialPoolBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void MaterialPoolBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

    _mfMaterials.terminateShare(uiAspect, this->getContainerSize());
}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

MaterialPoolBase::MaterialPoolBase(void) :
    _mfMaterials              (), 
    _sfRoot                   (NodePtr(NullFC)), 
    _sfLightRoot              (NodePtr(NullFC)), 
    _sfOverlayRoot            (NodePtr(NullFC)), 
    _sfLightSetsRoot          (NodePtr(NullFC)), 
    _sfConstraintsRoot        (NodePtr(NullFC)), 
    _sfCameraRoot             (NodePtr(NullFC)), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

MaterialPoolBase::MaterialPoolBase(const MaterialPoolBase &source) :
    _mfMaterials              (source._mfMaterials              ), 
    _sfRoot                   (source._sfRoot                   ), 
    _sfLightRoot              (source._sfLightRoot              ), 
    _sfOverlayRoot            (source._sfOverlayRoot            ), 
    _sfLightSetsRoot          (source._sfLightSetsRoot          ), 
    _sfConstraintsRoot        (source._sfConstraintsRoot        ), 
    _sfCameraRoot             (source._sfCameraRoot             ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

MaterialPoolBase::~MaterialPoolBase(void)
{
}

/*------------------------------ access -----------------------------------*/

SizeT  MaterialPoolBase::getBinSize(const BitVector &whichField)
{
    SizeT returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        returnValue += _mfMaterials.getBinSize();
    }

    if(FieldBits::NoField != (RootFieldMask & whichField))
    {
        returnValue += _sfRoot.getBinSize();
    }

    if(FieldBits::NoField != (LightRootFieldMask & whichField))
    {
        returnValue += _sfLightRoot.getBinSize();
    }

    if(FieldBits::NoField != (OverlayRootFieldMask & whichField))
    {
        returnValue += _sfOverlayRoot.getBinSize();
    }

    if(FieldBits::NoField != (LightSetsRootFieldMask & whichField))
    {
        returnValue += _sfLightSetsRoot.getBinSize();
    }

    if(FieldBits::NoField != (ConstraintsRootFieldMask & whichField))
    {
        returnValue += _sfConstraintsRoot.getBinSize();
    }

    if(FieldBits::NoField != (CameraRootFieldMask & whichField))
    {
        returnValue += _sfCameraRoot.getBinSize();
    }


    return returnValue;
}

void MaterialPoolBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        _mfMaterials.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RootFieldMask & whichField))
    {
        _sfRoot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (LightRootFieldMask & whichField))
    {
        _sfLightRoot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (OverlayRootFieldMask & whichField))
    {
        _sfOverlayRoot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (LightSetsRootFieldMask & whichField))
    {
        _sfLightSetsRoot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ConstraintsRootFieldMask & whichField))
    {
        _sfConstraintsRoot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (CameraRootFieldMask & whichField))
    {
        _sfCameraRoot.copyToBin(pMem);
    }


}

void MaterialPoolBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
    {
        _mfMaterials.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RootFieldMask & whichField))
    {
        _sfRoot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (LightRootFieldMask & whichField))
    {
        _sfLightRoot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (OverlayRootFieldMask & whichField))
    {
        _sfOverlayRoot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (LightSetsRootFieldMask & whichField))
    {
        _sfLightSetsRoot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ConstraintsRootFieldMask & whichField))
    {
        _sfConstraintsRoot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (CameraRootFieldMask & whichField))
    {
        _sfCameraRoot.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void MaterialPoolBase::executeSyncImpl(      MaterialPoolBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.syncWith(pOther->_mfMaterials);

    if(FieldBits::NoField != (RootFieldMask & whichField))
        _sfRoot.syncWith(pOther->_sfRoot);

    if(FieldBits::NoField != (LightRootFieldMask & whichField))
        _sfLightRoot.syncWith(pOther->_sfLightRoot);

    if(FieldBits::NoField != (OverlayRootFieldMask & whichField))
        _sfOverlayRoot.syncWith(pOther->_sfOverlayRoot);

    if(FieldBits::NoField != (LightSetsRootFieldMask & whichField))
        _sfLightSetsRoot.syncWith(pOther->_sfLightSetsRoot);

    if(FieldBits::NoField != (ConstraintsRootFieldMask & whichField))
        _sfConstraintsRoot.syncWith(pOther->_sfConstraintsRoot);

    if(FieldBits::NoField != (CameraRootFieldMask & whichField))
        _sfCameraRoot.syncWith(pOther->_sfCameraRoot);


}
#else
void MaterialPoolBase::executeSyncImpl(      MaterialPoolBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (RootFieldMask & whichField))
        _sfRoot.syncWith(pOther->_sfRoot);

    if(FieldBits::NoField != (LightRootFieldMask & whichField))
        _sfLightRoot.syncWith(pOther->_sfLightRoot);

    if(FieldBits::NoField != (OverlayRootFieldMask & whichField))
        _sfOverlayRoot.syncWith(pOther->_sfOverlayRoot);

    if(FieldBits::NoField != (LightSetsRootFieldMask & whichField))
        _sfLightSetsRoot.syncWith(pOther->_sfLightSetsRoot);

    if(FieldBits::NoField != (ConstraintsRootFieldMask & whichField))
        _sfConstraintsRoot.syncWith(pOther->_sfConstraintsRoot);

    if(FieldBits::NoField != (CameraRootFieldMask & whichField))
        _sfCameraRoot.syncWith(pOther->_sfCameraRoot);


    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.syncWith(pOther->_mfMaterials, sInfo);


}

void MaterialPoolBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

    if(FieldBits::NoField != (MaterialsFieldMask & whichField))
        _mfMaterials.beginEdit(uiAspect, uiContainerSize);

}
#endif



OSG_END_NAMESPACE

#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<MaterialPoolPtr>::_type("MaterialPoolPtr", "GroupPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(MaterialPoolPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(MaterialPoolPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.49 2008/06/09 07:30:44 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGMATERIALPOOLBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGMATERIALPOOLBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGMATERIALPOOLFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

